const StatusIconDispatcher = imports.ui.statusIconDispatcher;
const Main = imports.ui.main;
const Lang = imports.lang;
const St = imports.gi.St;
const Panel = imports.ui.main.panel;

let removeStatusIcon = [
    'a11y',         // Accessibility
    'bluetooth'    // Bluetooth
    // 'volume',
    // 'battery',
    // 'keyboard',
    // 'network'
]

let iconConnectId = null;
let oldemit = null;

function _onTrayIconAdded(o,icon) {
    let wmClass = (icon.wm_class || 'unknown').toLowerCase();
    let role = wmClass;
    Main.statusIconDispatcher.oldemit('status-icon-added',icon,role);
}

function _onTrayIconRemoved(o,icon) {
    Main.statusIconDispatcher.oldemit('status-icon-removed',icon);
}

function enable() {
    Main.statusIconDispatcher.oldemit = Main.statusIconDispatcher.emit;
    Main.statusIconDispatcher.emit = function() {};
    iconConnectId = Main.statusIconDispatcher._traymanager.connect('tray-icon-added',
        Lang.bind(Main.statusIconDispatcher,_onTrayIconAdded));
    iconRemoveConnectId = Main.statusIconDispatcher._traymanager.connect('tray-icon-removed',
        Lang.bind(Main.statusIconDispatcher,_onTrayIconRemoved));
    for(let e=0;e < removeStatusIcon.length;e++) {
        Panel._statusArea[removeStatusIcon[e]].actor.hide();
    }
}

function init() {
}

function disable() {
    Main.statusIconDispatcher._traymanager.disconnect(iconConnectId);
    Main.statusIconDispatcher._traymanager.disconnect(iconRemoveConnectId);
    Main.statusIconDispatcher.emit = Main.statusIconDispatcher.oldemit;
    for(let e=0;e < removeStatusIcon.length;e++) {
        Panel._statusArea[removeStatusIcon[e]].actor.show();
    }
}
